<?php
/*
Plugin Name: Delete-revision
Plugin URI: http://blog.gohsy.com
Description: Delete revision post from Database , let us now to drop Redundancy, lose weight !
Author: gohsy
Version: 1.1
Author URI: http://gohsy.com
*/

	if(!get_option('del_revision_no')) {update_option("del_revision_no",0);}
	if(!get_option('del_revision_getPosts')) {update_option("del_revision_getPosts",0);}
	

function delete_revision_main() {
    if (function_exists('add_options_page')) {
	add_options_page('Delete-Revision', 'Delete-Revision',8, basename(__FILE__), 'my_options_delete_revision');
    }
 }

add_action('admin_menu', 'delete_revision_main');

function my_options_delete_revision() {
	$dr_ver = 1.1;
	$get_my_posts = get_my_posts();
	$del_revision_no = get_option('del_revision_no');
	echo <<<EOT
	<div class="wrap">
		<h2>Delete-revision Manager  <font size=1>ver $dr_ver</font></h2>
		<div style="padding:5px 0;border:1px dashed #80B5D0;padding:10px;background:#E4F2FD;margin:15px 0;">
		您目前发布了<span style="color:red;font-weight:bolder;"> $get_my_posts </span>
		篇日志，截止目前，Delete-revision 共为您轻松删除了
		<span style="color:red;font-weight:bolder;"> $del_revision_no </span>
		篇冗余的 revision 日志，祝您愉快！
		</div>	
EOT;
		
	if (isset($_POST['del_act'])) {
		delete_revision_act();
		$del_no = $_POST['rev_no'];
		update_option("del_revision_no",get_option("del_revision_no") + $del_no);
		echo '<div class="updated" style="margin-top:50px;"><p><strong>已删除 <span style="color:red;font-weight:bolder;">  '.$del_no.' </span>篇冗余的 revision 日志！</strong></p></div></div>';
	}
	elseif (isset($_POST['get_rev'])) {
		get_my_revision();
		
	}
	else {
		echo <<<EOT
		<form method="post" action="">
		<input type="submit" name="get_rev" value="检查冗余 revision 数量" /> 
		</form></div>
EOT;
	}
	
	echo <<<EOT
	<div style="line-height:22px;padding:5px 0;border:1px dashed #80B5D0;padding:10px;background:#E4F2FD;margin:15px;">
	Revision Post 是 WordPress 在2.6版之后加入自动保存日志修订版造成，您每修改一次日志，就会增加一个 revision ， 如果您修改多次，数篇日志之后，这将是一个很可怕的数量！您如果有上百篇的日志，您的冗余 revisiong 可能会有上千篇之多！<br />
	Revision Manager 正是为此而来，删除大量冗余 revision 对提高 SQL 语句执行速度，提升 WordPress 运行速度有很大的好处！<br />
	非常感谢您的使用。希望本插件能给您带来方便！作者：<a href="http://www.gohsy.com" target="_blank">http://www.gohsy.com</a>
	</div>
EOT;
}

function get_my_posts() {
	global $wpdb;
	
	$sql = "SELECT ID
			FROM (
			$wpdb->posts
			)
			WHERE `post_type` = 'post'";
	$results = $wpdb -> get_results($sql);
	return count($results);
}

function get_my_revision() {
	global $wpdb;
	
	$sql = "SELECT `ID` , `post_date` , `post_title` , `post_modified`
			FROM (
			$wpdb->posts
			)
			WHERE `post_type` = 'revision'
			ORDER BY `ID` DESC";
	$results = $wpdb -> get_results($sql);
	if($results) {
	$res_no = count($results);
	echo "<table>";
	echo "<tr style=\"background:#C6D9E9\"><td width=30> Id </td><td width=450> Title </td><td width=180> Post date </td><td width=180> Last modified </td></tr>";
	for($i = 0 ; $i < $res_no ; $i++) {
		echo "<tr><td>".$results[$i] -> ID."</td>";
		echo "<td>".$results[$i] -> post_title."</td>";
		echo "<td>".$results[$i] -> post_date."</td>";
		echo "<td>".$results[$i] -> post_modified."</td></tr>";
	}
	echo "</table><br />";
	echo <<<EOT
		<form method="post" action="">
		<input type="hidden" name="rev_no" value=" $res_no " />
		<input type="submit" name="del_act" value="Yes , 我要删除它们！（共 $res_no 篇）" /> 
		<input type="submit" name="goback" value="No , 我改主意了不删了！" />
		</form></div>
EOT;
	}
	else {echo "<div class=\"updated\" style=\"margin:50px 0;padding:6px;line-height:16pt;font-weight:bolder;\">太棒了，您的wordpress还没有发现冗余的 revision 日志 ! <br />今天又是您美好的一天 ！</div></div>";}
}

function delete_revision_act() {
	global $wpdb;
	
	$sql = "DELETE FROM $wpdb->posts WHERE post_type = 'revision'";
	$results = $wpdb -> get_results($sql);


}

?>